package mongo

import (
	"context"
	productModel "git.chillcy.com/golang/colorway/internal/pkg/database/mongo/model/product"
	sitePlatformPriceConfigModel "git.chillcy.com/golang/colorway/internal/pkg/database/mongo/model/site_platform_price_config"
	reflect2 "git.chillcy.com/golang/colorway/pkg/reflect"
	"reflect"
)

const DatabaseColorWay = "color_way"

type Manager struct {
	ProductModel                 productModel.ProductModel
	SitePlatformPriceConfigModel sitePlatformPriceConfigModel.SitePlatformPriceConfigModel
}

func NewManager(mongoUrl string) *Manager {
	return &Manager{
		ProductModel:                 productModel.NewProductModel(mongoUrl, DatabaseColorWay, productModel.Collection),
		SitePlatformPriceConfigModel: sitePlatformPriceConfigModel.NewSitePlatformPriceConfigModel(mongoUrl, DatabaseColorWay, sitePlatformPriceConfigModel.Collection),
	}
}

func (receiver *Manager) StartCache() error {
	ctx := context.TODO()
	args := []reflect.Value{
		reflect.ValueOf(ctx),
	}
	return reflect2.MemberMethodCall(receiver, "StartCache", args)
}
